﻿Imports System.ServiceModel
Imports System.ServiceModel.Channels


<ServiceContract()>
Friend Interface IPingService
    <OperationContract()>
    Sub Ping()
End Interface

Friend Class PingService
	Implements IPingService
	Public Sub Ping() Implements IPingService.Ping
        Dim remote = TryCast(OperationContext.Current.IncomingMessageProperties(RemoteEndpointMessageProperty.Name), 
            RemoteEndpointMessageProperty)
		Console.WriteLine("Ping from {0}:{1}", remote.Address, remote.Port)

        If OperationContext.Current.ServiceSecurityContext IsNot Nothing AndAlso
            OperationContext.Current.ServiceSecurityContext.AuthorizationContext IsNot Nothing AndAlso
            OperationContext.Current.ServiceSecurityContext.AuthorizationContext.ClaimSets IsNot Nothing Then
            Console.WriteLine("Claims")
            Console.WriteLine("======")
            For Each cs In OperationContext.Current.ServiceSecurityContext.AuthorizationContext.ClaimSets
                For Each claim In cs
                    Console.WriteLine("ClaimType = {0}, Value ={1}", claim.ClaimType.Split("/"c).Last(), claim.Resource)
                Next claim
            Next cs
        End If

	End Sub
End Class